
   var shiftPressed;
    shiftPressed = false;	

    function aKeyDown(e) {
      e=window.event;
      if (e.keyCode==16) 
		shiftPressed=true;
    }

    function aKeyUp(e) {
      e=window.event;
      if (e.keyCode==16)
		shiftPressed=false;
    }

//*****************************************************************************
// Do not remove this notice.
//
// Copyright 2001 by Mike Hall.
// See http://www.brainjar.com for terms of use.
//*****************************************************************************

// Determine browser and version.

function Browser() {

  var ua, s, i;

  this.isIE    = false;
  this.isNS    = false;
  this.version = null;

  ua = navigator.userAgent;

  s = "MSIE";
  if ((i = ua.indexOf(s)) >= 0) {
    this.isIE = true;
    this.version = parseFloat(ua.substr(i + s.length));
    return;
  }

  s = "Netscape6/";
  if ((i = ua.indexOf(s)) >= 0) {
    this.isNS = true;
    this.version = parseFloat(ua.substr(i + s.length));
    return;
  }

  // Treat any other "Gecko" browser as NS 6.1.

  s = "Gecko";
  if ((i = ua.indexOf(s)) >= 0) {
    this.isNS = true;
    this.version = 6.1;
    return;
  }
}

var browser = new Browser();

// Global object to hold drag information.

// Reset the held drag object information
function drawObjReset()
{
    dragObjComic = null; // The last selection comic object
    dragObj = new Object();
    dragObj.zIndex = 0;
    dragObj.zIndexLow = -1; // Used to sending to the back
}

var dragObjComic = null; // The last selection comic object
var dragObj = new Object();

drawObjReset();

var sResizeDirection;

// Instead of passing object ID, just pass the object!
function dragStartReadID(event, objectRef, sResize)
{
    dragStart(event, objectRef.id, sResize);
}

// bIsResize: false (Drag the element about) / true (Resize the element)
function dragStart(event, id, sResize) 
{
  if ( id == null )
    return false;

  var el;
  var x, y;
  
  sResizeDirection = sResize;

  // If an element id was given, find it. Otherwise use the element being
  // clicked on.

  if (id)
    dragObj.elNode = document.getElementById(id);
  else {
    if (browser.isIE)
      dragObj.elNode = window.event.srcElement;
    if (browser.isNS)
      dragObj.elNode = event.target;

    // If this is a text node, use its parent element.

    if (dragObj.elNode.nodeType == 3)
      dragObj.elNode = dragObj.elNode.parentNode;
  }

  // Get cursor position with respect to the page.

  if (browser.isIE) {
    x = window.event.clientX + document.documentElement.scrollLeft
      + document.body.scrollLeft;
    y = window.event.clientY + document.documentElement.scrollTop
      + document.body.scrollTop;
  }
  if (browser.isNS) {
    x = event.clientX + window.scrollX;
    y = event.clientY + window.scrollY;
  }


  // If object is a Sprite or Textbox, store reference
  if ( dragObj.elNode.typeID != null )
  {
    if ( dragObj.elNode.id != null )
        DebugShow( 'Selected object, id: ' + dragObj.elNode.id );
  
    // If a previous object was selected - unselect it
    if ( dragObjComic != null )
    {
        if ( dragObjComic.locked )
            dragObjComic.className = 'ResizerOuterLocked'
        else
            dragObjComic.className = 'ResizerOuter'
            
        // Was the previous item a textbox? If so, unselect the tail
        if ( dragObjComic.typeID == 1 )
            document.getElementById('TextboxTail' + dragObjComic.id ).className = dragObjComic.className;
    }

    // Store new reference
    dragObjComic = document.getElementById(dragObj.elNode.id);;
    
    // Highlight new selected object
    dragObjComic.className = 'ResizerOuterSelected';
    
    // If textbox - highlight tail
    if ( dragObjComic.typeID == 1 )
        document.getElementById('TextboxTail' + dragObjComic.id ).className = dragObjComic.className;
  } 

  // Save starting positions of cursor and element.

  dragObj.cursorStartX = x;
  dragObj.cursorStartY = y;
  dragObj.elStartLeft  = parseInt(dragObj.elNode.style.left, 10);
  dragObj.elStartTop   = parseInt(dragObj.elNode.style.top,  10);

  if (isNaN(dragObj.elStartLeft)) dragObj.elStartLeft = 0;
  if (isNaN(dragObj.elStartTop))  dragObj.elStartTop  = 0;

  // Bring to front - only if not a comic object (sprite/textbox)
  if ( dragObj.elNode.typeID == null )    
    dragObj.elNode.style.zIndex = ++dragObj.zIndex;

  // Capture mousemove and mouseup events on the page.

  if (browser.isIE) {
    document.attachEvent("onmousemove", dragGo);
    document.attachEvent("onmouseup",   dragStop);
    window.event.cancelBubble = true;
    window.event.returnValue = false;
  }
  if (browser.isNS) {
    document.addEventListener("mousemove", dragGo,   true);
    document.addEventListener("mouseup",   dragStop, true);
    event.preventDefault();
  }
  
  // Show the properties of the selected object
  DisplayPropertiesText();
  DisplayProperties();
}

function dragGo(event) {

    // If selected object is locked, don't move it
    if ( dragObj.elNode.locked )
        return false;


  var x, y;
  
  // Show object position
  DisplayProperties();

  // Get cursor position with respect to the page.

  if (browser.isIE) {
    x = window.event.clientX + document.documentElement.scrollLeft
      + document.body.scrollLeft;
    y = window.event.clientY + document.documentElement.scrollTop
      + document.body.scrollTop;
  }
  if (browser.isNS) {
    x = event.clientX + window.scrollX;
    y = event.clientY + window.scrollY;
  }
  
  // document.getElementById('DebugOutput').value = "x: " + x + " y: " + y + " dragObj.elStartLeft: " + dragObj.elStartLeft + " dragObj.cursorStartX: " + dragObj.cursorStartX;
 
  // Resize or move element?
  if ( sResizeDirection != null )
  { // Resize
  
	// var iLeft = parseInt( dragObj.elNode.style.left.replace( "px", "" ), 10 );
	var iLeft = Number( dragObj.elNode.style.left.replace( "px", "" ) );
	var iTop = Number( dragObj.elNode.style.top.replace( "px", "" ) );
	var iHeight = Number( dragObj.elNode.style.height.replace( "px", "" ) );
	var iWidth = Number( dragObj.elNode.style.width.replace( "px", "" ) );
	
	// Get panel X and Y position
	// var oCurrentPanel = document.getElementById('Panel' + GetCurrentPanel() );
	var oCurrentPanel = dragObj.elNode.parentNode;
	
	// DebugShow( 'Parent element: ' + dragObj.elNode.parentNode );
	
	var iCurrentPanelLeft = Number( oCurrentPanel.style.left.replace( "px", "" ) );
	var iCurrentPanelTop = Number( oCurrentPanel.style.top.replace( "px", "" ) );
	
	// DebugShow( "Left: " + oCurrentPanel.style.left + " Top: " + oCurrentPanel.style.top );	
	
	var iAspectRatio = iWidth / iHeight;
	// window.status = "iAspectRatio: " + iAspectRatio;
	
 
	// Top
	if ( sResizeDirection.indexOf( "n" ) != -1 )
	{
		if ( y < (iTop + iHeight - iCurrentPanelTop) )
		{
			dragObj.elNode.style.height = (iHeight + (iTop - y) - iCurrentPanelTop) + "px";
			dragObj.elNode.style.top = (y + iCurrentPanelTop) + "px";	
		}
	}

	// Bottom
	if ( sResizeDirection.indexOf( "s" ) != -1 )
		if ( y - iTop - iCurrentPanelTop > 0 )
			dragObj.elNode.style.height = (y - iTop - iCurrentPanelTop) + "px";	
				
	// Right
	if ( sResizeDirection.indexOf( "e" ) != -1 )
		if ( x - iLeft - iCurrentPanelLeft> 0 )
			dragObj.elNode.style.width = (x - iLeft - iCurrentPanelLeft) + "px";		

	// Left
	if ( sResizeDirection.indexOf( "w" ) != -1 )
	{
		if ( (iWidth + (iLeft - x) - iCurrentPanelLeft) > 0 )
		{
			dragObj.elNode.style.width = (iWidth + (iLeft - x) - iCurrentPanelLeft) + "px";
			dragObj.elNode.style.left = (x - iCurrentPanelLeft) + "px";
		}
	}

  }
  else
  { // Move
	dragObj.elNode.style.left = (dragObj.elStartLeft + x - dragObj.cursorStartX) + "px";
	dragObj.elNode.style.top  = (dragObj.elStartTop  + y - dragObj.cursorStartY) + "px";
  }

  if (browser.isIE) {
    window.event.cancelBubble = true;
    window.event.returnValue = false;
  }
  if (browser.isNS)
    event.preventDefault();
}

function dragStop(event) {

  // Stop capturing mousemove and mouseup events.

  if (browser.isIE) {
    document.detachEvent("onmousemove", dragGo);
    document.detachEvent("onmouseup",   dragStop);
  }
  if (browser.isNS) {
    document.removeEventListener("mousemove", dragGo,   true);
    document.removeEventListener("mouseup",   dragStop, true);
  }
}